Subject: bug#37455: closed (Re: bug#37455: 27.0.50; insert-behind-hooks and insert-in-front-hooks in text properties do nothing when font-lock-mode is on)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 19 Sep 2019 17:36:02 +0000

Your bug report

#37455: 27.0.50; insert-behind-hooks and insert-in-front-hooks in text properties do nothing when font-lock-mode is on

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
37455: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=37455
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#37455: 27.0.50; insert-behind-hooks and insert-in-front-hooks in text properties do nothing when font-lock-mode is on
From: Eli Zaretskii <[email-masked]>
To: Ihor Radchenko <[email-masked]>
Cc: [email-masked]
Date: Thu, 19 Sep 2019 20:35:13 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Ihor Radchenko <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 20 Sep 2019 00:46:52 +0800
> 
> Thanks!
> I can confirm that the hooks work as expected in master.

Thanks, I'm therefore closing this bug report.

> "Too bad they have names that end in -hooks, which is misleading. Even
> if they were actually hooks (which are variables), because their
> functions take arguments they would be considered "abnormal
> hooks", and abnormal hooks are conventionally named with the
> suffix -functions (not -hooks). Following that convention would
> also be less misleading, lessening the suggestion that they're
> hooks."
> 
> Would it make sense to change the text and overlay property names to
> something like insert-in-front-functions, insert-behind-functions, and
> modification-functions?

I don't see a serious enough reason to change names of these
properties, which were introduced in Emacs 19(!).  The person who
wrote that raises many similar arguments, so I'm not surprised to hear
this one.

IOW, this ship has sailed decades ago, and it's too late to rename it
now.

Thanks.

Subject: 27.0.50; insert-behind-hooks and insert-in-front-hooks in text properties do nothing when font-lock-mode is on
From: 'Ihor Radchenko' <[email-masked]>
To: [email-masked]
Date: Thu, 19 Sep 2019 08:48:57 +0800
List-Id: <debbugs-submit.debbugs.gnu.org>

Expected behaviour:

According to the manual, adding insert-in-front-hooks or
insert-behind-hooks text properties should trigger the functions listed
in the hooks when the text is inserted in front/behind the text.

Observed behaviour:

The functions never run unless I type very fast (with my own config) or
when font-lock-mode is enabled.

Steps to reproduce (the font-lock part):
1. emacs -Q
2. Insert the following elisp into scratch (the code is from https://www.reddit.com/r/emacs/comments/d5waor/how_to_use_modification_hooks_in_text_properties/):

(defun test-property ()
  (put-text-property (point) (mark) 'insert-behind-hooks
		  (list (lambda (beg end)
			     (message "before %d %d" beg end))))
  (put-text-property (point) (mark) 'insert-in-front-hooks
		  (list (lambda (beg end)
			     (message "in front %d %d" beg end)))))

1. Select the region containing all the text in the scratch buffer
2. M-: (test-property) RET
3. Try to type anything
4. No message is shown
5. Disable font-lock-mode
6. Try to type anything
7. The message is shown

Regards,
Ihor

-- 
Ihor Radchenko,
PhD,
Center for Advancing Materials Performance from the Nanoscale (CAMP-nano)
State Key Laboratory for Mechanical Behavior of Materials, Xi'an Jiaotong University, Xi'an, China
Email: [email-masked], [email-masked]